diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
index 5838e868b..a9018839a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -12,41 +12,42 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class ItemSeeds extends Item {
-	private final @NotNull Block<?> cropsBlock;
+    private final @NotNull Block<?> cropsBlock;
 
-	public ItemSeeds(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> cropsBlock) {
-		super(name, namespaceId, id);
-		this.cropsBlock = cropsBlock;
-	}
+    public ItemSeeds(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> cropsBlock) {
+        super(name, namespaceId, id);
+        this.cropsBlock = cropsBlock;
+    }
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(side.getDirection());
-		}
-		if(world.getBlockId(blockPos.down()) == Blocks.FARMLAND_DIRT.id() && world.canPlaceInsideBlock(blockPos)) {
-			if(world.setBlockIdNotify(blockPos, this.cropsBlock.id())) {
-				world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.cropsBlock, EnumBlockSoundEffectType.PLACE);
-				selfStack.consumeItem(player);
-				return true;
-			}
-		}
-		return false;
-	}
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+        }
+        if (world.getBlockId(blockPos.down(new TilePos())) == Blocks.FARMLAND_DIRT.id() && world.canPlaceInsideBlock(blockPos)) {
+            if (world.setBlockIdNotify(blockPos, this.cropsBlock.id())) {
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.cropsBlock, EnumBlockSoundEffectType.PLACE);
+                selfStack.consumeItem(player);
+                return true;
+            }
+        }
+        return false;
+    }
 
-	@Override
-	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-		blockPos = blockPos.add(direction);
-		Block<?> b = world.getBlock(blockPos);
-		boolean isFarmland = Block.hasLogicClass(b, BlockLogicFarmland.class);
-		if (b == null || isFarmland || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-			onUseOnBlock(selfStack, world, null, blockPos.add(0, isFarmland ? 1 : 0, 0), direction.getSide(), 0.5, 0.5);
-		}
-	}
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        Block<?> b = world.getBlock(blockPos);
+        boolean isFarmland = Block.hasLogicClass(b, BlockLogicFarmland.class);
+        if (b == null || isFarmland || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+            onUseOnBlock(selfStack, world, null, blockPos.add(0, isFarmland ? 1 : 0, 0, new TilePos()), direction.getSide(), 0.5, 0.5);
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index dc56c5d7f..4ccbb112d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -9,40 +9,39 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemSign extends Item
-{
+public class ItemSign extends Item {
 
-    public ItemSign(@NotNull String name, @NotNull String namespaceId, int id)
-    {
+    public ItemSign(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player == null || side == Side.BOTTOM || !world.getBlockMaterial(blockPos).isSolid()) {
             return false;
         }
 
-        if(!world.canPlaceInsideBlock(blockPos)) {
-            blockPos.add(side.getDirection());
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
         }
 
-        if (blockPos.y < 0 || blockPos.y >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK.canPlaceAt(world, blockPos)) {
+        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK.canPlaceAt(world, blockPos)) {
             return false;
         }
 
-        if(side == Side.TOP) {
-            world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.SIGN_POST_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockIdDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK.id(), MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        if (side == Side.TOP) {
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_POST_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
+            world.setBlockIdDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK.id(), MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         } else {
-            world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
             world.setBlockIdDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK.id(), side.getId());
         }
         selfStack.consumeItem(player);
-        if(world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
+        if (world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if (selfStack.getData().containsKey("tileEntityData")) {
                 sign.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
             } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
index ef39c0805..8b5907dd1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
@@ -9,38 +9,39 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemSignPainted extends ItemSign{
+public class ItemSignPainted extends ItemSign {
     public ItemSignPainted(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player == null || side == Side.BOTTOM || !world.getBlockMaterial(blockPos).isSolid()) {
             return false;
         }
 
-        if(!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection());
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
         }
 
-        if (blockPos.y < 0 || blockPos.y >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK_PAINTED.canPlaceAt(world, blockPos)) {
+        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK_PAINTED.canPlaceAt(world, blockPos)) {
             return false;
         }
 
-        if(side == Side.TOP) {
-            int direction = MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf;
-            world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
+        if (side == Side.TOP) {
+            int direction = MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf;
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
             world.setBlockIdDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.id(), Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | direction);
         } else {
-            world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
             world.setBlockIdDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED.id(), Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.getId());
         }
         selfStack.consumeItem(player);
-        if(world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
+        if (world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if (selfStack.getData().containsKey("tileEntityData")) {
                 sign.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
             } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
index b1fa88776..03373e16e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -29,8 +29,8 @@ public class ItemSnowball extends Item implements IDispensable {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        ProjectileSnowball snowball = new ProjectileSnowball(world, blockPos.x + offX, blockPos.y + offY, blockPos.z + offZ);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        ProjectileSnowball snowball = new ProjectileSnowball(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
         snowball.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
         world.entityJoinedWorld(snowball);
         selfStack.stackSize -= 1;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
index 808e0e342..4e60566c0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -9,62 +9,63 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class ItemStatue extends Item {
-	protected final @NotNull Block<?> statueBlockBottom;
-	protected final @NotNull Block<?> statueBlockTop;
+    protected final @NotNull Block<?> statueBlockBottom;
+    protected final @NotNull Block<?> statueBlockTop;
 
-	public ItemStatue(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> statueBlockBottom, @NotNull Block<?> statueBlockTop) {
-		super(name, namespaceId, id);
+    public ItemStatue(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> statueBlockBottom, @NotNull Block<?> statueBlockTop) {
+        super(name, namespaceId, id);
         this.maxStackSize = 64;
         this.statueBlockBottom = statueBlockBottom;
         this.statueBlockTop = statueBlockTop;
     }
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(side.getDirection());
-		}
-		if(!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
-			return false;
-		}
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+        }
+        if (!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
+            return false;
+        }
 
-		world.noNeighborUpdate = true;
-		world.setBlockIdDataNotify(blockPos, this.statueBlockBottom.id(), MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-		world.setBlockIdDataNotify(blockPos.up(), this.statueBlockTop.id(), MathHelper.floor((double)(((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-		world.noNeighborUpdate = false;
-		world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom.id());
-		world.notifyBlocksOfNeighborChange(blockPos.up(), this.statueBlockTop.id());
-		world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
-		this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-		this.statueBlockTop.onPlacedByMob(world, blockPos.up(), side, player, xHit, yHit);
-		selfStack.consumeItem(player);
-		return true;
-	}
+        world.noNeighborUpdate = true;
+        world.setBlockIdDataNotify(blockPos, this.statueBlockBottom.id(), MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.statueBlockTop.id(), MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        world.noNeighborUpdate = false;
+        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom.id());
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop.id());
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
+        this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
+        this.statueBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
+        selfStack.consumeItem(player);
+        return true;
+    }
 
-	@Override
-	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(direction);
-		}
-		if(!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
-			return;
-		}
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(direction, new TilePos());
+        }
+        if (!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
+            return;
+        }
 
-		world.noNeighborUpdate = true;
-		world.setBlockIdNotify(blockPos, this.statueBlockBottom.id());
-		world.setBlockIdNotify(blockPos.up(), this.statueBlockTop.id());
-		world.noNeighborUpdate = false;
-		world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom.id());
-		world.notifyBlocksOfNeighborChange(blockPos.up(), this.statueBlockTop.id());
-		world.playBlockSoundEffect(null, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
-		this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
-		this.statueBlockTop.onPlacedOnSide(world, blockPos.up(), direction.getSide(), 0.5, 0.5);
-		selfStack.consumeItem(null);
-	}
+        world.noNeighborUpdate = true;
+        world.setBlockIdNotify(blockPos, this.statueBlockBottom.id());
+        world.setBlockIdNotify(blockPos.up(new TilePos()), this.statueBlockTop.id());
+        world.noNeighborUpdate = false;
+        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom.id());
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop.id());
+        world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
+        this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
+        this.statueBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
+        selfStack.consumeItem(null);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
index 3047a0911..3e0999e68 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
@@ -7,7 +7,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -34,7 +34,7 @@ public class ItemWandNBT extends Item{
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player == null) return false;
         TileEntity te = world.getTileEntity(blockPos);
         if (te != null) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index cb7440cb1..09285a34e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -9,7 +9,7 @@ import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -33,7 +33,7 @@ public class ItemWandSpawner extends Item implements IDispensable
 
             if (rayTraceResult != null){
                 if (!world.isClientSide){
-                    spawnEntity(selfStack, world, rayTraceResult.location.x, rayTraceResult.location.y, rayTraceResult.location.z);
+                    spawnEntity(selfStack, world, rayTraceResult.location.x(), rayTraceResult.location.y(), rayTraceResult.location.z());
                 }
                 return selfStack;
             }
@@ -72,7 +72,7 @@ public class ItemWandSpawner extends Item implements IDispensable
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        spawnEntity(selfStack, world, blockPos.x + offX + direction.getOffsetX() * 0.5, blockPos.y + offY + direction.getOffsetY() * 0.5, blockPos.z + offZ + direction.getOffsetZ() * 0.5);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        spawnEntity(selfStack, world, blockPos.x() + offX + direction.getOffsetX() * 0.5, blockPos.y() + offY + direction.getOffsetY() * 0.5, blockPos.z() + offZ + direction.getOffsetZ() * 0.5);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index 022d2f998..3578ffb7e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -13,6 +13,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -32,19 +33,19 @@ public class ItemBlock<T extends BlockLogic> extends Item {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-        if(selfStack.stackSize <= 0) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (selfStack.stackSize <= 0) {
             return false;
         }
-        if(!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection());
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
         }
-        if(blockPos.y < 0 || blockPos.y >= world.getHeightBlocks()) {
+        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
             return false;
         }
-        if(world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
+        if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
             int meta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if(world.setBlockIdDataNotify(blockPos, this.block.id(), meta)) {
+            if (world.setBlockIdDataNotify(blockPos, this.block.id(), meta)) {
                 if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
@@ -56,7 +57,7 @@ public class ItemBlock<T extends BlockLogic> extends Item {
                         tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
                     }
                 }
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 return true;
             } else if (player == null || player.getGamemode().consumeBlocks()) {
                 selfStack.stackSize += 1;
@@ -66,16 +67,16 @@ public class ItemBlock<T extends BlockLogic> extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
         Block<?> b = world.getBlock(blockPos);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
             onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
         }
     }
 
-    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-    	return this.block.getPlacedData(player, selfStack, world, blockPos, side, xHit, yHit);
+    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        return this.block.getPlacedData(player, selfStack, world, blockPos, side, xHit, yHit);
     }
 
     @Override
@@ -84,8 +85,7 @@ public class ItemBlock<T extends BlockLogic> extends Item {
     }
 
     @Override
-    public @NotNull String getKey()
-    {
+    public @NotNull String getKey() {
         return this.block.getKey();
     }
 }
